# Extend Python search path to all available modules in a LCG release
# author: Marco Clemencic <marco.clemencic@cern.ch>
import sys
from os.path import basename, dirname, join, isdir, exists
from os import listdir

lcg_root = dirname(dirname(dirname(sys.prefix)))
platform = basename(sys.prefix)
suffix = join(platform, 'lib', 'python%d.%d' % sys.version_info[:2],
              'site-packages')

if exists(join(lcg_root, 'LCG_externals_%s.txt' % platform)):
    sys.path.extend(
        join(pkg, vers, suffix) for pkg in [
            join(lcg_root, pkg) for pkg in sorted(listdir(lcg_root))
            if isdir(join(lcg_root, pkg))
        ] for vers in listdir(pkg) if isdir(join(pkg, vers, suffix)))
