#!/bin/sh

# Sets the parameters depending on the config
# lb: for LHCb, at for Atlas

TYPE=${1:-"lcg"}
case "$TYPE" in
"lb")
	MOD="LHCbConfig"
	;;
"at")
	MOD="AtlasConfig"
	;;
"lcg")
	MOD="LCGConfig"
	;;

esac

echo "==> $TYPE - $MOD"

cat > ${TYPE}_install.sh <<EOF
#!/bin/sh
export PYTHONPATH="\$0":"\$PYTHONPATH"
exec python -c "from LbInstall import LbInstall; LbInstall('$MOD', '\$0')" \$*
EOF

#(zip -q -r - . -i "*.py" -i "*.pyc") | \
(zip -q -r - . -i "LbInstall.py*" -i "*DependencyManager.py*" -i "${MOD}.py*") | \
    tee -a ${TYPE}_install.sh > /dev/null

chmod a+x ${TYPE}_install.sh
